unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DXDraws, StdCtrls, DXClass;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    bmpfile: TEdit;
    brs: TButton;
    dd: TDXDraw;
    imgs: TDXImageList;
    trcy: TTrackBar;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    mt: TDXTimer;
    trcx: TTrackBar;
    trcrs: TTrackBar;
    Label3: TLabel;
    rs: TLabel;
    inf: TLabel;
    hnd: TCheckBox;
    hl: TLabel;
    procedure rend;
    procedure LoadImage;
    procedure ChangeDirection;
    procedure updinf;
    procedure brsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bmpfileChange(Sender: TObject);
    procedure mtTimer(Sender: TObject; LagCount: Integer);
    procedure trcrsChange(Sender: TObject);
    procedure trcyChange(Sender: TObject);
    procedure trcxChange(Sender: TObject);
    procedure hndClick(Sender: TObject);
    procedure hndKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure hndKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
//ROT -  ,  - 
// 180  128 ""    
//    
//CROT -     (  
//    ,     ...)
//PX,PY -  
//X,Y -   
//CX,CY -  ""  (   )
  Form1: TForm1;
  rot,crot,px,py:integer;
  x,y,cx,cy:real;

implementation

{$R *.dfm}

procedure TForm1.ChangeDirection;
//   
var n:real;
dddd:integer;
begin
//  ""  
if (cx=0) and (cy=0) then exit;
//   CX=0,  ,    ...
if (cx=0) then if (cy>0) then begin rot:=128; exit; end else begin rot:=0; exit; end;
//     ,     :)
n:=cy/cx;
//  ,    ...
if (cx<0) then dddd:=-64 else dddd:=64;
rot:=round(128*arctan(n)/pi)+dddd;
end;

procedure TForm1.updinf;
begin
//   
Label2.caption:='Rotation: '+inttostr(rot);
inf.Caption:=inttostr(round(cx*100))+' x '+inttostr(round(cy*100));
end;

procedure TForm1.trcrsChange(Sender: TObject);
begin
//  
mt.Interval:=100-trcrs.position;
rs.Caption:=inttostr(trcrs.Position);
end;

procedure TForm1.mtTimer(Sender: TObject; LagCount: Integer);
begin
//   
x:=x+cx;
y:=y+cy;
// ...
if (x<-px) then x:=369;
if (x>369) then x:=-px;
if (y<-py) then y:=185;
if (y>185) then y:=-py;
//  "",    
if (cx=0) and (cy=0) then rot:=crot;
//   
if (crot<rot) then crot:=crot+4;
if (crot>rot) then crot:=crot-4;
//    
rend;
end;

procedure TForm1.rend;
begin
//!!!  !!!
//    (  )
dd.Surface.Fill(0);
//  ,    :)
if (crot=0) or (crot=-256) or (crot=256) then begin
imgs.Items.Items[0].Draw(dd.Surface,round(x),round(y),0);
end else begin
//  
imgs.Items.Items[0].DrawRotate(dd.surface,round(x+px/2),round(y+py/2),px,py,0,0.5,0.5,crot);
end;
//    
dd.Flip;
end;

procedure TFOrm1.LoadImage;
begin
//  
if not fileexists(bmpfile.Text) then exit;
   with imgs.Items.Items[0] do
   begin
      Picture.LoadFromFile (bmpfile.Text);
      SkipHeight := 0;
      SkipWidth := 0;
      SystemMemory := False;
      TransparentColor := clwhite;
      Restore;
   end;
//    
px:=imgs.Items.Items[0].Picture.Width;
py:=imgs.Items.Items[0].Picture.height;
end;

procedure TForm1.brsClick(Sender: TObject);
begin
//  
if not opendialog1.Execute then exit;
bmpfile.Text:=opendialog1.FileName;
loadimage;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
// Direct Draw
dd.Initialize;
//    
px:=22;
py:=22;
x:=173;
y:=81;
end;

procedure TForm1.bmpfileChange(Sender: TObject);
begin
//  ,  
//    .
loadimage;
end;

procedure TForm1.trcyChange(Sender: TObject);
begin
//   
if (hnd.Checked) then exit;
cy:=trcy.Position/100;
ChangeDirection;
updinf;
end;

procedure TForm1.trcxChange(Sender: TObject);
begin
//   
if (hnd.Checked) then exit;
cx:=trcx.Position/100;
ChangeDirection;
updinf;
end;

procedure TForm1.hndClick(Sender: TObject);
begin
//  
cx:=0;
cy:=0;
if (hnd.Checked) then hl.Caption:='H:---' else begin
hl.Caption:='';
cy:=trcy.Position/100;
cx:=trcx.Position/100;
end;
ChangeDirection;
updinf;
end;

procedure TForm1.hndKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var k:char;
  begin
if not hnd.Checked then exit;
k:=chr(key);
if (k='w') or (k='W') then cy:=-1;
if (k='s') or (k='S') then cy:=1;
if (k='a') or (k='A') then cx:=-1;
if (k='d') or (k='D') then cx:=1;
ChangeDirection;
updinf;
hl.Caption:='H:'+k;
end;

procedure TForm1.hndKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var k:char;
  begin
if not hnd.Checked then exit;
k:=chr(key);
if (k='w') or (k='W') then if cy=-1 then cy:=0;
if (k='s') or (k='S') then if cy=1 then cy:=0;
if (k='a') or (k='A') then if cx=-1 then cx:=0;
if (k='d') or (k='D') then if cx=1 then cx:=0;
ChangeDirection;
updinf;
hl.Caption:='H:---';
end;

end.
